package cz.muni.cv3csfd.activity;

import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.widget.ImageView;
import android.widget.TextView;

import com.squareup.picasso.Picasso;

import cz.muni.cv3csfd.R;
import cz.muni.cv3csfd.model.MovieDetail;
import cz.muni.cv3csfd.network.Api;
import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

public class MovieDetailActivity extends AppCompatActivity {

	TextView name;
	TextView rating;
	ImageView poster;
	TextView plot;

	@Override

	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_detail);
		initUI();

		long movieId = getIntent().getLongExtra("id", 0);
		Api.get().getMovie(movieId).enqueue(new Callback<MovieDetail>() {
			@Override public void onResponse(Call<MovieDetail> call, Response<MovieDetail> response) {
				if (response.isSuccessful()) {
					MovieDetail detail = response.body();
					name.setText(detail.names.cs);
					Picasso.with(MovieDetailActivity.this).load(detail.poster_url).into(poster);
					rating.setText(String.valueOf(detail.rating));
					plot.setText(detail.descr);
				} else {
					// TODO handle server error
				}
			}

			@Override public void onFailure(Call<MovieDetail> call, Throwable t) {
				// TODO handle connection error
			}
		});
	}

	private void initUI() {
		name = (TextView) findViewById(R.id.name);
		poster = (ImageView) findViewById(R.id.poster);
		rating = (TextView) findViewById(R.id.rating);
		plot = (TextView) findViewById(R.id.plot);
	}
}
