package cz.muni.cv3csfd.activity;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;

import java.util.List;

import cz.muni.cv3csfd.R;
import cz.muni.cv3csfd.adapter.MovieAdapter;
import cz.muni.cv3csfd.model.MovieListItem;
import cz.muni.cv3csfd.network.Api;
import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

public class MovieListActivity extends AppCompatActivity {

	private EditText query;
	private ListView list;
	private Button search;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_movie_list);
		initUI();

		search.setOnClickListener(new View.OnClickListener() {
			@Override public void onClick(View v) {
				String query = MovieListActivity.this.query.getText().toString();
				Api.get().getMovies(query).enqueue(new Callback<List<MovieListItem>>() {
					@Override public void onResponse(Call<List<MovieListItem>> call, Response<List<MovieListItem>> response) {
						if (response.isSuccessful()) {
							list.setAdapter(new MovieAdapter(MovieListActivity.this, response.body()));

							list.setOnItemClickListener(new AdapterView.OnItemClickListener() {
								@Override public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
									Intent i = new Intent(MovieListActivity.this, MovieDetailActivity.class);
									i.putExtra("id", id);
									startActivity(i);
								}
							});
						} else {
							// TODO handle server error
						}
					}

					@Override public void onFailure(Call<List<MovieListItem>> call, Throwable t) {
						// TODO handle connection error
					}
				});
			}
		});
	}

	private void initUI() {
		query = (EditText) findViewById(R.id.query);
		list = (ListView) findViewById(R.id.list);
		search = (Button) findViewById(R.id.search);
	}
}
