package cz.muni.cv3csfd.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.squareup.picasso.Picasso;

import java.util.List;

import cz.muni.cv3csfd.R;
import cz.muni.cv3csfd.model.MovieListItem;

public class MovieAdapter extends BaseAdapter {

	LayoutInflater inflater;
	Context context;
	List<MovieListItem> movies;

	public MovieAdapter(Context context, List<MovieListItem> movies) {
		this.inflater = LayoutInflater.from(context);
		this.context = context;
		this.movies = movies;
	}

	@Override public int getCount() {
		return movies.size();
	}

	@Override public MovieListItem getItem(int position) {
		return movies.get(position);
	}

	@Override public long getItemId(int position) {
		return getItem(position).id;
	}

	@Override public View getView(int position, View convertView, ViewGroup parent) {
		if (convertView == null) {
			convertView = inflater.inflate(R.layout.list_item_movie, parent, false);
			convertView.setTag(new ViewHolder(convertView));
		}

		ViewHolder holder = (ViewHolder) convertView.getTag();

		MovieListItem item = getItem(position);

		holder.name.setText(item.names.cs);
		Picasso.with(context).load(item.poster_url).into(holder.poster);

		return convertView;
	}

	class ViewHolder {
		public ImageView poster;
		public TextView name;

		private ViewHolder(View view) {
			poster = (ImageView) view.findViewById(R.id.poster);
			name = (TextView) view.findViewById(R.id.name);
		}
	}
}
