package cz.muni.cv3csfd.network;

import java.util.List;

import cz.muni.cv3csfd.model.MovieDetail;
import cz.muni.cv3csfd.model.MovieListItem;
import okhttp3.OkHttpClient;
import okhttp3.logging.HttpLoggingInterceptor;
import retrofit2.Call;
import retrofit2.Retrofit;
import retrofit2.converter.gson.GsonConverterFactory;
import retrofit2.http.GET;
import retrofit2.http.Path;
import retrofit2.http.Query;

public class Api {
	private static final String URL = "http://csfdapi.cz/";

	public static ServerService serverService;

	public static ServerService get() {
		if (serverService == null) {
			HttpLoggingInterceptor logger = new HttpLoggingInterceptor();
			logger.setLevel(HttpLoggingInterceptor.Level.BODY);

			OkHttpClient client = new OkHttpClient.Builder()
					.addInterceptor(logger)
					.build();

			Retrofit retrofit = new Retrofit.Builder()
					.baseUrl(URL)
					.client(client)
					.addConverterFactory(GsonConverterFactory.create())
					.build();

			serverService = retrofit.create(ServerService.class);
		}

		return serverService;
	}

	public interface ServerService {

		@GET("movie")
		Call<List<MovieListItem>> getMovies(@Query("search") String search);

		@GET("movie/{id}")
		Call<MovieDetail> getMovie(@Path("id") long id);
	}
}
